<html><head><title>AJAX-php chat</title>
		
		<link rel="stylesheet" href="style.css" type="text/css">
	
		<script type="text/javascript">
		/*
		 * 
		 * AJAX Chat Client - Kevin Mesiab
		 *
		*/
		//
		// Global variables
		//
		var isFirefox;
		var isIE;
		var timeout;
		var pingtimeout;
		var pingsent	= 0;
		var requestsent = 0;
		var postsent	= 0;
		var chatsent	= 0;
		var pingRate	= 1000 * 30;	 // 20 seconds
		var refreshRate = 2000;			 // two seconds
		var rnd			= Math.random(); // random seed
		
		// added by David Sterry to allow user list to update less
		var count = 0;
		var update_period = 3;
		
		//
		// Get an XMLHttpRequest object
		//
		function getAjax() {
		
			if ( isFirefox ) {
			
				return new XMLHttpRequest();
			
			} else if ( isIE ) {
			
				try {
				
					return new ActiveXObject( "Msxml2.XMLHTTP" );
				
				} catch( ex ) {
				
					return new ActiveXObject( "Microsoft.XMLHTTP" );
				
				}
			
			}
			
		}
		//
		// Get a DOM element
		//
		function getElement( id ) {
		
			if( isIE ) {
			
				return document.all[ id ];
				
			}
			
			if( isFirefox ) {
			
				return document.getElementById( id );
			
			}
		}
		//
		// Get browser type
		//
		function sniff() {
		
			var ff = "Netscape";
			var ie = "Microsoft Internet Explorer";
			
			isFirefox = ( navigator.appName == ff );
			isIE = (navigator.appName == ie ); 
		}
		//
		// Measure and display the char count
		//
		function charCount()
		{
			if( isFirefox ) {
			
				charcount = getElement( "charcount" );
				
			}
			
			inputtext = getElement( "mytext" );
			charcount.innerHTML = (1+inputtext.value.length) + " characters";
		}
		//
		// Update the status text with some 
		// basic client statistics
		// 
		function updateStatus()
		{
			statistics = "<strong>Quick Stats</strong> Pings: " + pingsent + " Requests: " + requestsent + " Posts: " + postsent;
			
			if( isFirefox ) {
				stats = getElement( "stats" );
			}
			
			stats.innerHTML = statistics;
		}
		//
		// Capture the enter key on 
		// the input box and initiate a
		// GET to the post url
		//
		function captureReturn( event )
		{
			if( isIE ) {
			
				event = window.event;
			}
			//
			// Supress event bubbling
			//
			if( event.keyCode == 13 ) {
				//
				// fetch the feed
				//
				postText();
					
				if( isIE ) {
				
					event.returnValue = false;
					
				} else {
				
					event.preventDefault();
				
				}
			}
			
			charCount();
		}
		//
		// Auto scroll the chat window
		// if the text exceeds the div 
		//
		function scrollChatPane()
		{
			pane = getElement( "chatpane" );
			
			while( pane.scrollTop < pane.scrollHeight - pane.offsetHeight )
			{
				pane.scrollTop = pane.scrollTop + 10;
			}
		}
		//
		// Show the little loading animation
		// when the page starts
		//
		function showLoadScreen()
		{
			//var loading = "<div style=\"text-align:center;\"><h4>Loading...</h4><img src=\"images/spinwait.gif\" /></div>";
			var loading = "<div style=\"text-align:center;\"><h4>Loading...</h4></div>";
			
			chat = getElement( "chatbuffer" );
			user = getElement( "userlist" );
			
			chat.innerHTML = loading;
			user.innerHTML = loading;
		
		}
		//
		// ping the server to let 
		// it know we're still alive
		//
		function resetPing()
		{
			pingtimeout = window.setTimeout( "pingServer()", pingRate );
		}
		//
		// Start the fetch timer to update
		// the chatpane and userlist
		//
		function setTimers()
		{
			timeout = window.setTimeout( "fetch()", refreshRate );
		}
		//
		// Start the async fetch 
		// and reset the fetch timer
		//
		function fetch()
		{
			window.clearTimeout( timeout );
			fetchBufferText();
			if(count++ % update_period) { 
			  fetchUserList();
			} else {
			  fetchBufferText();
			}    
			setTimers();
		}
		/* #############################
		 * 
		 * function: fetchUserList()
		 * purpose:
		 * 
		 * This function retrieves the userlist.  
		 * The userlist is returned as a set of
		 * list-items from the server.  The existing
		 * list is replaced and the new list is rendered
		 * between two <ul> tags.  This function will 
		 * call to update the chat buffer when it completes.
		 *		 
		 * notes: A random number is generated 
		 * when this page loads.  This number is
		 * incrimented and appended to the url to
		 * prevent caching problems in IE
		 *
		 * #############################
		*/
		function fetchUserList()
		{
			rnd++;
			url = 'userlist.php?' + rnd;
			req = getAjax();
			
			req.onreadystatechange = function(){
			
				if( req.readyState == 4 && req.status == 200 ) {
				
					obj = getElement( "userlist" );
					obj.innerHTML = req.responseText;
					fetchBufferText();
				}
			
			}
			
			req.open( 'GET', url, true );
			req.send( null );
			
			requestsent++;
			updateStatus();
		}
		/* #############################
		 * 
		 * function: fetchBufferText()
		 * purpose:
		 * 
		 * This function retrieves the last 
		 * twenty lines of the chat buffer.
		 * The chat buffer is returned as a 
		 * set of list-items and are rendered
		 * in a <ul> tag.  This function calls
		 * the scroll function to scroll the 
		 * chat pane.
		 *
		 * notes: A random number is generated 
		 * when this page loads.  This number is
		 * incrimented and appended to the url to
		 * prevent caching problems in IE
		 *
		 * #############################
		*/
		function fetchBufferText()
		{
			url = 'buffertext.php?' + rnd;
			req = getAjax();
			
			req.onreadystatechange = function(){
			
				if( req.readyState == 4 && req.status == 200 ) {
				
					obj = getElement( "chatbuffer" );
					obj.innerHTML = req.responseText;
					scrollChatPane();
				}
			}
			
			req.open( 'GET', url , true );
			req.send( null );
			
			requestsent++;
			updateStatus();
		}
		/* #############################
		 * 
		 * function: postText()
		 * purpose:
		 * 
		 * A users chat is posted to the server in 
		 * the querystring of the posttext.aspx url.
		 * The format of the querystring is: 
		 *
		 * ?u=[username]&t=[chat text]
		 *
		 * Because of the nature of the url encoding
		 * certain chat text will fail to post.  
		 * The chat text cannot contain any values
		 * that are invalid in a url, or are part
		 * of the url structure, such as the ampersand (&)
		 * forward slash (/), etc.  
		 *
		 * #############################
		*/
		function postText()
		{
			chatbox = getElement( "mytext" );
			chat = chatbox.value;
			chatbox.value = "";
			
			user = location.search.substring( 1, location.search.length );
			url = 'posttext.php?u=' + user + '&t=' + chat;
			
			req = getAjax();
			
			req.onreadystatechange = function(){
			
				if( req.readyState == 4 && req.status == 200 ) {
				
					fetch();
				}
			
			}
			
			req.open( 'GET', url, true );
			req.send( null );
			
			postsent++;
			updateStatus();
		}
		/* #############################
		 * 
		 * function: pinServer()
		 * purpose:
		 * 
		 * A sends a message to the server indicating
		 * the browser is still open and the user is
		 * still alive.
		 *
		 * #############################
		*/
		function pingServer()
		{
			window.clearTimeout( pingtimeout );
			
			user = location.search.substring( 1, location.search.length );
			url = 'ping.php?u=' + user;
			
			req = getAjax();
			req.open( 'GET', url, true );
			req.send( null );
			
			pingsent++;
			updateStatus();
			
			resetPing();
		}
		
		</script></head>
	<body>
	
 
		
			<!--<div id="header">
				<h1>Chat-o-licious</h1>
				<h2>Web Chat, AJAX + php...</h2>
			</div>-->
			
			<div class="form">
					
				<div id="chatpane">
				  <ul id="chatbuffer">			

                  </ul>
				</div>
				
			    <div id="userpane">
				  <ul id="userlist">			

                  </ul>
			    </div>				
			
				
				<p class="clear">
			
				<label for="txtUsername">
					chat:
				</label>
				
				<input class="mytext" id="mytext" type="text">
				
				</p><p id="charcount">0 characters</p>
				<p id="stats"><strong>Quick Stats</strong> Pings: 0 Requests: 0 Posts: 0</p>
				
			</div>
			
			<script type="text/javascript">
			sniff();
			showLoadScreen();
			setTimers();
			resetPing();
			
			if( isFirefox ) {
				mytext = getElement( "mytext" );
			}
			mytext.focus();
			mytext.onkeypress = captureReturn;
		    </script>
	
	</body></html>